commit 41344d6077953bf1d16883bea638d31d355b96fd
Author: David Malcolm <dmalcolm@redhat.com>
Date:   Mon Sep 9 19:38:11 2024 -0400

    SARIF output: fix schema URL [§3.13.3, PR116603]
    
    We were using
      https://raw.githubusercontent.com/oasis-tcs/sarif-spec/master/Schemata/sarif-schema-2.1.0.json
    as the URL for the SARIF 2.1 schema, but this is now a 404.
    
    Update it to the URL listed in the spec (§3.13.3 "$schema property"),
    which is:
      https://docs.oasis-open.org/sarif/sarif/v2.1.0/errata01/os/schemas/sarif-schema-2.1.0.json
    and update the copy in
      gcc/testsuite/lib/sarif-schema-2.1.0.json
    used by the "verify-sarif-file" DejaGnu directive to the version found at
    that latter URL; the sha256 sum changes
    from: 2b19d2358baef0251d7d24e208d05ffabf1b2a3ab5e1b3a816066fc57fd4a7e8
      to: c3b4bb2d6093897483348925aaa73af03b3e3f4bd4ca38cef26dcb4212a2682e
    
    Doing so added a validation error on
      c-c++-common/diagnostic-format-sarif-file-pr111700.c
    for which we emit this textual output:
      this-file-does-not-exist.c: warning: #warning message [-Wcpp]
    with no line number, and these invalid SARIF regions within the
    physical location of the warning:
      "region": {"startColumn": 2,
                 "endColumn": 9},
      "contextRegion": {}
    
    This is due to this directive:
      # 0 "this-file-does-not-exist.c"
    with line number 0.
    
    The patch fixes this by not creating regions that have startLine <= 0.
    
    gcc/ChangeLog:
            PR other/116603
            * diagnostic-format-sarif.cc (SARIF_SCHEMA): Update URL.
            (sarif_builder::maybe_make_region_object): Don't create regions
            with startLine <= 0.
            (sarif_builder::maybe_make_region_object_for_context): Likewise.
    
    gcc/testsuite/ChangeLog:
            PR other/116603
            * lib/sarif-schema-2.1.0.json: Update with copy downloaded from
            https://docs.oasis-open.org/sarif/sarif/v2.1.0/errata01/os/schemas/sarif-schema-2.1.0.json
    
    Signed-off-by: David Malcolm <dmalcolm@redhat.com>
    (cherry picked from commit 38dc2c64710aa0e6a03c0c1201477e3e75b1a0b0)

diff --git a/gcc/diagnostic-format-sarif.cc b/gcc/diagnostic-format-sarif.cc
index d27614d6c87..d651913be8b 100644
--- a/gcc/diagnostic-format-sarif.cc
+++ b/gcc/diagnostic-format-sarif.cc
@@ -942,7 +942,10 @@ sarif_builder::get_sarif_column (expanded_location exploc) const
    or return NULL.
 
    If COLUMN_OVERRIDE is non-zero, then use it as the column number
-   if LOC has no column information.  */
+   if LOC has no column information.
+
+   We only support text properties of regions ("text regions"),
+   not binary properties ("binary regions"); see 3.30.1.  */
 
 json::object *
 sarif_builder::maybe_make_region_object (location_t loc,
@@ -965,11 +968,16 @@ sarif_builder::maybe_make_region_object (location_t loc,
   if (exploc_finish.file !=exploc_caret.file)
     return NULL;
 
+  /* We can have line == 0 in the presence of "#" lines.
+     SARIF requires lines > 0, so if we hit this case we don't have a
+     way of validly representing the region as SARIF; bail out.  */
+  if (exploc_start.line <= 0)
+    return nullptr;
+
   json::object *region_obj = new json::object ();
 
   /* "startLine" property (SARIF v2.1.0 section 3.30.5) */
-  if (exploc_start.line > 0)
-    region_obj->set_integer ("startLine", exploc_start.line);
+  region_obj->set_integer ("startLine", exploc_start.line);
 
   /* "startColumn" property (SARIF v2.1.0 section 3.30.6).
 
@@ -1034,11 +1042,16 @@ sarif_builder::maybe_make_region_object_for_context (location_t loc) const
   if (exploc_finish.file !=exploc_caret.file)
     return NULL;
 
+  /* We can have line == 0 in the presence of "#" lines.
+     SARIF requires lines > 0, so if we hit this case we don't have a
+     way of validly representing the region as SARIF; bail out.  */
+  if (exploc_start.line <= 0)
+    return nullptr;
+
   json::object *region_obj = new json::object ();
 
   /* "startLine" property (SARIF v2.1.0 section 3.30.5) */
-  if (exploc_start.line > 0)
-    region_obj->set_integer ("startLine", exploc_start.line);
+  region_obj->set_integer ("startLine", exploc_start.line);
 
   /* "endLine" property (SARIF v2.1.0 section 3.30.7) */
   if (exploc_finish.line != exploc_start.line
@@ -1308,7 +1321,7 @@ sarif_builder::make_multiformat_message_string (const char *msg) const
   return message_obj;
 }
 
-#define SARIF_SCHEMA "https://raw.githubusercontent.com/oasis-tcs/sarif-spec/master/Schemata/sarif-schema-2.1.0.json"
+#define SARIF_SCHEMA "https://docs.oasis-open.org/sarif/sarif/v2.1.0/errata01/os/schemas/sarif-schema-2.1.0.json"
 #define SARIF_VERSION "2.1.0"
 
 /* Make a top-level sarifLog object (SARIF v2.1.0 section 3.13).
